Subject: Re: [MOBILE-IP] Draft for Vendor/Organization Specific Extensions

From: Rajesh Bhalla <[email-masked]>
Date: Tue, 5 Oct 1999 14:41:02 -0500

Gopal,

   Read your upated version of the draft.  I was quirious as to why the choice
to have the
   "Length" field of TWO octets for the "Critical" type extensions and only ONE
octet for the
   "Normal" type extensions.

   In the context of the MIP extensions being considered by the TIA TSG-A task
group, it
   would  be nice to have "Length" field of TWO octets for "Normal" type
extensions also.
   For the TSG-A task group, we would like to propose the use of the
Organization
  Specific extension as an "envelope"  for passing multiple parameters between
the
  communicaiting entities. ONE octet length field would be a limitation on how
much could
  be packaged within one 'envelope".  It could be argued that there is the
option of including
  multiple TLVs within a message. It would be nice to have the flexibility with
a suffilicently
  large sized "envelope" too.

Thanks
Rajesh Bhalla

Gopal Dommety <[email-masked]> on 09/29/99 11:55:08 PM

Please respond to Gopal Dommety <[email-masked]>

Sent by:  Gopal Dommety <[email-masked]>

To:   [email-masked]
cc:    (Rajesh Bhalla/MW/US/3Com)
Subject:  Re: [MOBILE-IP] Draft for Vendor/Organization Specific Extensions

>
> Hi,
>
> For my curiosity, can you tell me why the length field in the Critical
> Vendor/Organization Specific Extension =20
> is 2 bytes long, and the length field in Normal Vendor/Organization
> Specific Extension is 1 byte long?

Hi Weijun,

Ideally, it would have been good to have both as two byte length. For
the Normal type if a HA does not understand it, it will have to skip
it according to RFC2002. In thi case the legth is assumed to be of
one byte. So, having a two byte lenght could create interoperability
problems. But for the Critical type, if the HA does not understand it
if discards it. If it does undertand it, HA will know how to process
it.

Hope this is helps.

thanks
Gopal

>
> br,
>
> weijun
>
> >
> > Mobile IP Working Group                                    Gopal
> Dommety
> > INTERNET DRAFT                                             Kent Leung
> > August 1999                                                Cisco
> Systems
> >
> >
> >             Vendor/Organization-Specific Extensions for Mobile IP
> >                   <draft-dommety-mobileip-vendor-ext-00.txt>
> >
> >
> > Status of this Memo
> >
> >    This document is an Internet Draft and is in full conformance with
> >>    all provisions of Section 10 of RFC2026. Internet Drafts are
> >>    working documents of the Internet Engineering Task Force (IETF),
> its
> >>    areas, and working groups. Note that other groups may also
> distribute
> >>    working documents as Internet Drafts.
> >>
> >>    Internet Drafts are draft documents valid for a maximum of six
> months
> >>    and may be updated, replaced, or obsoleted by other documents at
> any
> >>    time. It is inappropriate to use Internet Drafts as reference
> >>    material or to cite them other than as "work in progress."
> >>
> >>    The list of current Internet-Drafts can be accessed at
> >>    http://www.ietf.org/ietf/1id-abstracts.txt.
> >>
> >>    The list of Internet-Draft Shadow Directories can be accessed at
> >>    http://www.ietf.org/shadow.html.
> >>
> >> Abstract
> >>
> >>    This draft proposes an extensions that can be used as a vendor
> >>    or organization-Specific Extensions.  These extensions will
> facilitate
> >>    organizations to make specific extensions as they see fit for
> research
> >>    or deployment purposes.
> >>
> >> 1.0   Introduction
> >>
> >>    Current specification of Mobile IP [1] does not allow for
> >>    organizations and vendor to include organization/vendor-specific
> >>    extensions in the Mobile IP messages. With the wide scale
> deployment
> >>    of Mobile IP it is useful to have a vendor or
> organization-Specific
> >>    Extension.  This draft proposes  extensions that can be used for
> >>    making organization specific extensions.
> >>
> >>
> >> 2.0 Vendor/Organization Specific Extensions
> >>
> >> Two  Vendor/Organization Specific Extensions  are described,
> Critical
> >> and Normal    Vendor/Organization  Specific Extensions.     The
> basic
> >> differeces are between the Critical and  the Normal Extensions is
> that
> >> whan the  Critical extension  is encountered  but not  recognized,
> the
> >> message   containing the   extension    MUST  be   silently
> >> discarded.  Whereas   when   a  Normal   Vendor/Organization
> Specific
> >> Extension is encountered and not recognized, the extension is
> ignored,
> >> but  the  rest  of  the Extensions  and   message data  MUST still
> be
> >> processed. Another    difference between the    two is  that
> Critical
> >> Vendor/Organization Extension has a lenght feild of two bytes.
> >>
> >>
> >> 2.1 Critical Vendor/Organization Specific Extension
> >>
> >>    The format of this extension is as shown below.
> >>
> >>        0                   1                   2                   3
> >>        0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0
> 1
> >>
> +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
> >>       |     Type      |            Length             |   Vendor-ID
> >>
> +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
> >>                      Vendor-ID (cont)                 | Opaque
> Data...
> >>
> +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
> >>
> >>
> >>                 Figure 1: Vendor/Organization Specific Extension
> >>
> >>
> >>       Type       TBD-1 (value should be in the range of 0-127)
> >>
> >>       Length     Length in bytes of this extension, not including the=
>
> Type
> >>                  and Length bytes.
> >>
> >>       Vendor-ID
> >>                  The high-order octet is 0 and the low-order 3 octets=
>
> are the
> >>                  SMI Network Management Private Enterprise Code of
> the Vendor
> >>                  in network byte order, as defined in the Assigned
> Numbers
> >>                  RFC [2].
> >>
> >>       Opaque Data
> >>                  Vendor/organization specific data.  These data
> fields
> >>                  may be publicized in future RFCs.
> >>
> >> 2.2 Normal Vendor/Organization Specific Extension
> >>
> >>    The format of this extension is as shown below.
> >>
> >>        0                   1                   2                   3
> >>        0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0
> 1
> >>
> +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
> >>       |     Type      |    Length     |   Vendor-ID
> >>
> +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
> >>                  Vendor-ID (cont)     | Opaque Data...               =
> =20
> |
> >>
> +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
> >>
> >>
> >>                 Figure 1: Vendor/Organization Specific Extension
> >>
> >>
> >>       Type       TBD-2 (value should be in the range of 128-255)
> >>
> >>       Length     Length in bytes of this extension, not including the=
>
> Type
> >>                  and Length bytes.
> >>
> >>       Vendor-ID
> >>
> >>                  The high-order octet is  0 and the low-order 3
> octets
> >>                are the SMI Network Management Private Enterprise
> >>                Code of         the Vendor in network byte order, as
> >>                defined in the Assigned Numbers RFC [2].
> >>
> >>       Opaque Data
> >>                  Vendor/organization specific data.  These data
> fields
> >>                  may be publicized in future RFCs.
> >>
> >>
> >> 3.0 Restrictions
> >>
> >>    Multiple TLV's with the TBD-1 and TBD-2 types can  be included in
> a
> >> message. TLVs with TBD-1 and TBD-2 types can  be placed anywhere
> after
> >> the fixed  portion of the Mobile IP  meggase.  These TLVs are
> expected
> >> to  be protected by   the  corresponding authenticator as
> necessary.
> >> Ordering of these TLV's should not be modified by intermediate nodes.=
>
> >>
> >>
> >>
> >> 4.0 Security Considerations
> >>
> >>    This document assumes that the Mobile IP messages are
> authenticated
> >> using a method defined by the Mobile IP protocol.  This proposal does=
>
> >> not impose any additional requirements on Mobile IP messages from a
> >> security point of view. So this is not expected to be a security
> >> issue.
> >>
> >>
> >> 5.0 IPv6 considerations
> >>
> >>       This extension can be used in IPv4 and IPv6 alike.
> >>
> >> References
> >
> >    [1] C. Perkins, Editor.  IP Mobility Support.  RFC 2002, October
> >        1996.
> >    [2] Reynolds, J., and J. Postel, "Assigned Numbers", STD 2, RFC
> >        1700, USC/Information Sciences Institute, October 1994.
> >
> > Authors' Addresses
> >
>
>
> --openmail-part-01027968-00000002
> Content-Type: application/rtf; name="BDY.RTF"
> Content-Disposition: attachment; filename="BDY.RTF"
> Content-Transfer-Encoding: base64
>
> e1xydGYxXGFuc2lcYW5zaWNwZzEyNTJcZnJvbXRleHQgXGRlZmYwe1xmb250dGJsDQp7XGYw
> XGZzd2lzcyBBcmlhbDt9DQp7XGYxXGZtb2Rlcm4gQ291cmllciBOZXc7fQ0Ke1xmMlxmbmls
> XGZjaGFyc2V0MiBTeW1ib2w7fQ0Ke1xmM1xmbW9kZXJuXGZjaGFyc2V0MCBDb3VyaWVyIE5l
> dzt9fQ0Ke1xjb2xvcnRibFxyZWQwXGdyZWVuMFxibHVlMDtccmVkMFxncmVlbjBcYmx1ZTI1
> NTt9DQpcdWMxXHBhcmRccGxhaW5cZGVmdGFiMzYwIFxmMFxmczIwXGNmMCBIaSxccGFyDQpc
> cGFyDQpGb3IgbXkgY3VyaW9zaXR5LCBjYW4geW91IHRlbGwgbWUgd2h5IHRoZSBsZW5ndGgg
> ZmllbGQgaW4gdGhlIENyaXRpY2FsIFZlbmRvci9Pcmdhbml6YXRpb24gU3BlY2lmaWMgRXh0
> ZW5zaW9uIFxwYXINCmlzIDIgYnl0ZXMgbG9uZywgYW5kIHRoZSBsZW5ndGggZmllbGQgaW4g
> Tm9ybWFsIFZlbmRvci9Pcmdhbml6YXRpb24gU3BlY2lmaWMgRXh0ZW5zaW9uIGlzIDEgYnl0
> ZSBsb25nP1xwYXINClxwYXINCmJyLFxwYXINClxwYXINCndlaWp1blxwYXINClxwYXINCj5c
> cGFyDQo+IE1vYmlsZSBJUCBXb3JraW5nIEdyb3VwICAgICAgICAgICAgICAgICAgICAgICAg
> ICAgICAgICAgICAgR29wYWwgRG9tbWV0eVxwYXINCj4gSU5URVJORVQgRFJBRlQgICAgICAg
> ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICBLZW50IExldW5nXHBhcg0K
> PiBBdWd1c3QgMTk5OSAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
> ICAgICAgIENpc2NvIFN5c3RlbXNccGFyDQo+XHBhcg0KPlxwYXINCj4gICAgICAgICAgICAg
> VmVuZG9yL09yZ2FuaXphdGlvbi1TcGVjaWZpYyBFeHRlbnNpb25zIGZvciBNb2JpbGUgSVBc
> cGFyDQo+ICAgICAgICAgICAgICAgICAgIDxkcmFmdC1kb21tZXR5LW1vYmlsZWlwLXZlbmRv
> ci1leHQtMDAudHh0PlxwYXINCj5ccGFyDQo+XHBhcg0KPiBTdGF0dXMgb2YgdGhpcyBNZW1v
> XHBhcg0KPlxwYXINCj4gICAgVGhpcyBkb2N1bWVudCBpcyBhbiBJbnRlcm5ldCBEcmFmdCBh
> bmQgaXMgaW4gZnVsbCBjb25mb3JtYW5jZSB3aXRoXHBhcg0KPj4gICAgYWxsIHByb3Zpc2lv
> bnMgb2YgU2VjdGlvbiAxMCBvZiBSRkMyMDI2LiBJbnRlcm5ldCBEcmFmdHMgYXJlXHBhcg0K
> Pj4gICAgd29ya2luZyBkb2N1bWVudHMgb2YgdGhlIEludGVybmV0IEVuZ2luZWVyaW5nIFRh
> c2sgRm9yY2UgKElFVEYpLCBpdHNccGFyDQo+PiAgICBhcmVhcywgYW5kIHdvcmtpbmcgZ3Jv
> dXBzLiBOb3RlIHRoYXQgb3RoZXIgZ3JvdXBzIG1heSBhbHNvIGRpc3RyaWJ1dGVccGFyDQo+
> PiAgICB3b3JraW5nIGRvY3VtZW50cyBhcyBJbnRlcm5ldCBEcmFmdHMuXHBhcg0KPj5ccGFy
> DQo+PiAgICBJbnRlcm5ldCBEcmFmdHMgYXJlIGRyYWZ0IGRvY3VtZW50cyB2YWxpZCBmb3Ig
> YSBtYXhpbXVtIG9mIHNpeCBtb250aHNccGFyDQo+PiAgICBhbmQgbWF5IGJlIHVwZGF0ZWQs
> IHJlcGxhY2VkLCBvciBvYnNvbGV0ZWQgYnkgb3RoZXIgZG9jdW1lbnRzIGF0IGFueVxwYXIN
> Cj4+ICAgIHRpbWUuIEl0IGlzIGluYXBwcm9wcmlhdGUgdG8gdXNlIEludGVybmV0IERyYWZ0
> cyBhcyByZWZlcmVuY2VccGFyDQo+PiAgICBtYXRlcmlhbCBvciB0byBjaXRlIHRoZW0gb3Ro
> ZXIgdGhhbiBhcyAid29yayBpbiBwcm9ncmVzcy4iXHBhcg0KPj5ccGFyDQo+PiAgICBUaGUg
> bGlzdCBvZiBjdXJyZW50IEludGVybmV0LURyYWZ0cyBjYW4gYmUgYWNjZXNzZWQgYXRccGFy
> DQo+PiAgICBodHRwOi8vd3d3LmlldGYub3JnL2lldGYvMWlkLWFic3RyYWN0cy50eHQuXHBh
> cg0KPj5ccGFyDQo+PiAgICBUaGUgbGlzdCBvZiBJbnRlcm5ldC1EcmFmdCBTaGFkb3cgRGly
> ZWN0b3JpZXMgY2FuIGJlIGFjY2Vzc2VkIGF0XHBhcg0KPj4gICAgaHR0cDovL3d3dy5pZXRm
> Lm9yZy9zaGFkb3cuaHRtbC5ccGFyDQo+PlxwYXINCj4+IEFic3RyYWN0XHBhcg0KPj5ccGFy
> DQo+PiAgICBUaGlzIGRyYWZ0IHByb3Bvc2VzIGFuIGV4dGVuc2lvbnMgdGhhdCBjYW4gYmUg
> dXNlZCBhcyBhIHZlbmRvclxwYXINCj4+ICAgIG9yIG9yZ2FuaXphdGlvbi1TcGVjaWZpYyBF
> eHRlbnNpb25zLiAgVGhlc2UgZXh0ZW5zaW9ucyB3aWxsIGZhY2lsaXRhdGVccGFyDQo+PiAg
> ICBvcmdhbml6YXRpb25zIHRvIG1ha2Ugc3BlY2lmaWMgZXh0ZW5zaW9ucyBhcyB0aGV5IHNl
> ZSBmaXQgZm9yIHJlc2VhcmNoXHBhcg0KPj4gICAgb3IgZGVwbG95bWVudCBwdXJwb3Nlcy5c
> cGFyDQo+PlxwYXINCj4+IDEuMCAgIEludHJvZHVjdGlvblxwYXINCj4+XHBhcg0KPj4gICAg
> Q3VycmVudCBzcGVjaWZpY2F0aW9uIG9mIE1vYmlsZSBJUCBbMV0gZG9lcyBub3QgYWxsb3cg
> Zm9yXHBhcg0KPj4gICAgb3JnYW5pemF0aW9ucyBhbmQgdmVuZG9yIHRvIGluY2x1ZGUgb3Jn
> YW5pemF0aW9uL3ZlbmRvci1zcGVjaWZpY1xwYXINCj4+ICAgIGV4dGVuc2lvbnMgaW4gdGhl
> IE1vYmlsZSBJUCBtZXNzYWdlcy4gV2l0aCB0aGUgd2lkZSBzY2FsZSBkZXBsb3ltZW50XHBh
> cg0KPj4gICAgb2YgTW9iaWxlIElQIGl0IGlzIHVzZWZ1bCB0byBoYXZlIGEgdmVuZG9yIG9y
> IG9yZ2FuaXphdGlvbi1TcGVjaWZpY1xwYXINCj4+ICAgIEV4dGVuc2lvbi4gIFRoaXMgZHJh
> ZnQgcHJvcG9zZXMgIGV4dGVuc2lvbnMgdGhhdCBjYW4gYmUgdXNlZCBmb3JccGFyDQo+PiAg
> ICBtYWtpbmcgb3JnYW5pemF0aW9uIHNwZWNpZmljIGV4dGVuc2lvbnMuXHBhcg0KPj5ccGFy
> DQo+PlxwYXINCj4+IDIuMCBWZW5kb3IvT3JnYW5pemF0aW9uIFNwZWNpZmljIEV4dGVuc2lv
> bnNccGFyDQo+PlxwYXINCj4+IFR3byAgVmVuZG9yL09yZ2FuaXphdGlvbiBTcGVjaWZpYyBF
> eHRlbnNpb25zICBhcmUgZGVzY3JpYmVkLCAgQ3JpdGljYWxccGFyDQo+PiBhbmQgTm9ybWFs
> ICAgIFZlbmRvci9Pcmdhbml6YXRpb24gIFNwZWNpZmljIEV4dGVuc2lvbnMuICAgICBUaGUg
> IGJhc2ljXHBhcg0KPj4gZGlmZmVyZWNlcyBhcmUgYmV0d2VlbiB0aGUgQ3JpdGljYWwgYW5k
> ICB0aGUgTm9ybWFsIEV4dGVuc2lvbnMgaXMgdGhhdFxwYXINCj4+IHdoYW4gdGhlICBDcml0
> aWNhbCBleHRlbnNpb24gIGlzIGVuY291bnRlcmVkICBidXQgbm90ICByZWNvZ25pemVkLCB0
> aGVccGFyDQo+PiBtZXNzYWdlICAgY29udGFpbmluZyB0aGUgICBleHRlbnNpb24gICAgTVVT
> VCAgYmUgICBzaWxlbnRseVxwYXINCj4+IGRpc2NhcmRlZC4gIFdoZXJlYXMgICB3aGVuICAg
> YSAgTm9ybWFsICAgVmVuZG9yL09yZ2FuaXphdGlvbiAgU3BlY2lmaWNccGFyDQo+PiBFeHRl
> bnNpb24gaXMgZW5jb3VudGVyZWQgYW5kIG5vdCByZWNvZ25pemVkLCB0aGUgZXh0ZW5zaW9u
> IGlzIGlnbm9yZWQsXHBhcg0KPj4gYnV0ICB0aGUgIHJlc3QgIG9mICB0aGUgRXh0ZW5zaW9u
> cyAgYW5kICAgbWVzc2FnZSBkYXRhICBNVVNUIHN0aWxsICBiZVxwYXINCj4+IHByb2Nlc3Nl
> ZC4gQW5vdGhlciAgICBkaWZmZXJlbmNlIGJldHdlZW4gdGhlICAgIHR3byBpcyAgdGhhdCAg
> Q3JpdGljYWxccGFyDQo+PiBWZW5kb3IvT3JnYW5pemF0aW9uIEV4dGVuc2lvbiBoYXMgYSBs
> ZW5naHQgZmVpbGQgb2YgdHdvIGJ5dGVzLlxwYXINCj4+XHBhcg0KPj5ccGFyDQo+PiAyLjEg
> Q3JpdGljYWwgVmVuZG9yL09yZ2FuaXphdGlvbiBTcGVjaWZpYyBFeHRlbnNpb25ccGFyDQo+
> PlxwYXINCj4+ICAgIFRoZSBmb3JtYXQgb2YgdGhpcyBleHRlbnNpb24gaXMgYXMgc2hvd24g
> YmVsb3cuXHBhcg0KPj5ccGFyDQo+PiAgICAgICAgMCAgICAgICAgICAgICAgICAgICAxICAg
> ICAgICAgICAgICAgICAgIDIgICAgICAgICAgICAgICAgICAgM1xwYXINCj4+ICAgICAgICAw
> IDEgMiAzIDQgNSA2IDcgOCA5IDAgMSAyIDMgNCA1IDYgNyA4IDkgMCAxIDIgMyA0IDUgNiA3
> IDggOSAwIDFccGFyDQo+PiAgICAgICArLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0r
> LSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstK1xwYXINCj4+ICAgICAgIHwgICAg
> IFR5cGUgICAgICB8ICAgICAgICAgICAgTGVuZ3RoICAgICAgICAgICAgIHwgICBWZW5kb3It
> SURccGFyDQo+PiAgICAgICArLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0r
> LSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstK1xwYXINCj4+ICAgICAgICAgICAgICAgICAg
> ICAgIFZlbmRvci1JRCAoY29udCkgICAgICAgICAgICAgICAgIHwgT3BhcXVlIERhdGEuLi5c
> cGFyDQo+PiAgICAgICArLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSst
> Ky0rLSstKy0rLSstKy0rLSstKy0rLSstK1xwYXINCj4+XHBhcg0KPj5ccGFyDQo+PiAgICAg
> ICAgICAgICAgICAgRmlndXJlIDE6IFZlbmRvci9Pcmdhbml6YXRpb24gU3BlY2lmaWMgRXh0
> ZW5zaW9uXHBhcg0KPj5ccGFyDQo+PlxwYXINCj4+ICAgICAgIFR5cGUgICAgICAgVEJELTEg
> KHZhbHVlIHNob3VsZCBiZSBpbiB0aGUgcmFuZ2Ugb2YgMC0xMjcpXHBhcg0KPj5ccGFyDQo+
> PiAgICAgICBMZW5ndGggICAgIExlbmd0aCBpbiBieXRlcyBvZiB0aGlzIGV4dGVuc2lvbiwg
> bm90IGluY2x1ZGluZyB0aGUgVHlwZVxwYXINCj4+ICAgICAgICAgICAgICAgICAgYW5kIExl
> bmd0aCBieXRlcy5ccGFyDQo+PlxwYXINCj4+ICAgICAgIFZlbmRvci1JRFxwYXINCj4+ICAg
> ICAgICAgICAgICAgICAgVGhlIGhpZ2gtb3JkZXIgb2N0ZXQgaXMgMCBhbmQgdGhlIGxvdy1v
> cmRlciAzIG9jdGV0cyBhcmUgdGhlXHBhcg0KPj4gICAgICAgICAgICAgICAgICBTTUkgTmV0
> d29yayBNYW5hZ2VtZW50IFByaXZhdGUgRW50ZXJwcmlzZSBDb2RlIG9mIHRoZSBWZW5kb3Jc
> cGFyDQo+PiAgICAgICAgICAgICAgICAgIGluIG5ldHdvcmsgYnl0ZSBvcmRlciwgYXMgZGVm
> aW5lZCBpbiB0aGUgQXNzaWduZWQgTnVtYmVyc1xwYXINCj4+ICAgICAgICAgICAgICAgICAg
> UkZDIFsyXS5ccGFyDQo+PlxwYXINCj4+ICAgICAgIE9wYXF1ZSBEYXRhXHBhcg0KPj4gICAg
> ICAgICAgICAgICAgICBWZW5kb3Ivb3JnYW5pemF0aW9uIHNwZWNpZmljIGRhdGEuICBUaGVz
> ZSBkYXRhIGZpZWxkc1xwYXINCj4+ICAgICAgICAgICAgICAgICAgbWF5IGJlIHB1YmxpY2l6
> ZWQgaW4gZnV0dXJlIFJGQ3MuXHBhcg0KPj5ccGFyDQo+PiAyLjIgTm9ybWFsIFZlbmRvci9P
> cmdhbml6YXRpb24gU3BlY2lmaWMgRXh0ZW5zaW9uXHBhcg0KPj5ccGFyDQo+PiAgICBUaGUg
> Zm9ybWF0IG9mIHRoaXMgZXh0ZW5zaW9uIGlzIGFzIHNob3duIGJlbG93LlxwYXINCj4+XHBh
> cg0KPj4gICAgICAgIDAgICAgICAgICAgICAgICAgICAgMSAgICAgICAgICAgICAgICAgICAy
> ICAgICAgICAgICAgICAgICAgIDNccGFyDQo+PiAgICAgICAgMCAxIDIgMyA0IDUgNiA3IDgg
> OSAwIDEgMiAzIDQgNSA2IDcgOCA5IDAgMSAyIDMgNCA1IDYgNyA4IDkgMCAxXHBhcg0KPj4g
> ICAgICAgKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSst
> Ky0rLSstKy0rLSstKy0rLStccGFyDQo+PiAgICAgICB8ICAgICBUeXBlICAgICAgfCAgICBM
> ZW5ndGggICAgIHwgICBWZW5kb3ItSURccGFyDQo+PiAgICAgICArLSstKy0rLSstKy0rLSst
> Ky0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstK1xwYXIN
> Cj4+ICAgICAgICAgICAgICAgICAgVmVuZG9yLUlEIChjb250KSAgICAgfCBPcGFxdWUgRGF0
> YS4uLiAgICAgICAgICAgICAgICB8XHBhcg0KPj4gICAgICAgKy0rLSstKy0rLSstKy0rLSst
> Ky0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLSstKy0rLStccGFyDQo+
> PlxwYXINCj4+XHBhcg0KPj4gICAgICAgICAgICAgICAgIEZpZ3VyZSAxOiBWZW5kb3IvT3Jn
> YW5pemF0aW9uIFNwZWNpZmljIEV4dGVuc2lvblxwYXINCj4+XHBhcg0KPj5ccGFyDQo+PiAg
> ICAgICBUeXBlICAgICAgIFRCRC0yICh2YWx1ZSBzaG91bGQgYmUgaW4gdGhlIHJhbmdlIG9m
> IDEyOC0yNTUpXHBhcg0KPj5ccGFyDQo+PiAgICAgICBMZW5ndGggICAgIExlbmd0aCBpbiBi
> eXRlcyBvZiB0aGlzIGV4dGVuc2lvbiwgbm90IGluY2x1ZGluZyB0aGUgVHlwZVxwYXINCj4+
> ICAgICAgICAgICAgICAgICAgYW5kIExlbmd0aCBieXRlcy5ccGFyDQo+PlxwYXINCj4+ICAg
> ICAgIFZlbmRvci1JRFxwYXINCj4+XHBhcg0KPj4gICAgICAgICAgICAgICAgICBUaGUgaGln
> aC1vcmRlciBvY3RldCBpcyAgMCBhbmQgdGhlIGxvdy1vcmRlciAzIG9jdGV0c1xwYXINCj4+
> ICAgICAgICAgICAgICAgIGFyZSB0aGUgU01JIE5ldHdvcmsgTWFuYWdlbWVudCBQcml2YXRl
> IEVudGVycHJpc2VccGFyDQo+PiAgICAgICAgICAgICAgICBDb2RlIG9mICAgICAgICAgdGhl
> IFZlbmRvciBpbiBuZXR3b3JrIGJ5dGUgb3JkZXIsIGFzXHBhcg0KPj4gICAgICAgICAgICAg
> ICAgZGVmaW5lZCBpbiB0aGUgQXNzaWduZWQgTnVtYmVycyBSRkMgWzJdLlxwYXINCj4+XHBh
> cg0KPj4gICAgICAgT3BhcXVlIERhdGFccGFyDQo+PiAgICAgICAgICAgICAgICAgIFZlbmRv
> ci9vcmdhbml6YXRpb24gc3BlY2lmaWMgZGF0YS4gIFRoZXNlIGRhdGEgZmllbGRzXHBhcg0K
> Pj4gICAgICAgICAgICAgICAgICBtYXkgYmUgcHVibGljaXplZCBpbiBmdXR1cmUgUkZDcy5c
> cGFyDQo+PlxwYXINCj4+XHBhcg0KPj4gMy4wIFJlc3RyaWN0aW9uc1xwYXINCj4+XHBhcg0K
> Pj4gICAgTXVsdGlwbGUgVExWJ3Mgd2l0aCB0aGUgVEJELTEgYW5kIFRCRC0yIHR5cGVzIGNh
> biAgYmUgaW5jbHVkZWQgaW4gYVxwYXINCj4+IG1lc3NhZ2UuIFRMVnMgd2l0aCBUQkQtMSBh
> bmQgVEJELTIgdHlwZXMgY2FuICBiZSBwbGFjZWQgYW55d2hlcmUgYWZ0ZXJccGFyDQo+PiB0
> aGUgZml4ZWQgIHBvcnRpb24gb2YgdGhlIE1vYmlsZSBJUCAgbWVnZ2FzZS4gIFRoZXNlIFRM
> VnMgYXJlIGV4cGVjdGVkXHBhcg0KPj4gdG8gIGJlIHByb3RlY3RlZCBieSAgIHRoZSAgY29y
> cmVzcG9uZGluZyBhdXRoZW50aWNhdG9yIGFzICAgbmVjZXNzYXJ5LlxwYXINCj4+IE9yZGVy
> aW5nIG9mIHRoZXNlIFRMVidzIHNob3VsZCBub3QgYmUgbW9kaWZpZWQgYnkgaW50ZXJtZWRp
> YXRlIG5vZGVzLlxwYXINCj4+XHBhcg0KPj5ccGFyDQo+PlxwYXINCj4+IDQuMCBTZWN1cml0
> eSBDb25zaWRlcmF0aW9uc1xwYXINCj4+XHBhcg0KPj4gICAgVGhpcyBkb2N1bWVudCBhc3N1
> bWVzIHRoYXQgdGhlIE1vYmlsZSBJUCBtZXNzYWdlcyBhcmUgYXV0aGVudGljYXRlZFxwYXIN
> Cj4+IHVzaW5nIGEgbWV0aG9kIGRlZmluZWQgYnkgdGhlIE1vYmlsZSBJUCBwcm90b2NvbC4g
> IFRoaXMgcHJvcG9zYWwgZG9lc1xwYXINCj4+IG5vdCBpbXBvc2UgYW55IGFkZGl0aW9uYWwg
> cmVxdWlyZW1lbnRzIG9uIE1vYmlsZSBJUCBtZXNzYWdlcyBmcm9tIGFccGFyDQo+PiBzZWN1
> cml0eSBwb2ludCBvZiB2aWV3LiBTbyB0aGlzIGlzIG5vdCBleHBlY3RlZCB0byBiZSBhIHNl
> Y3VyaXR5XHBhcg0KPj4gaXNzdWUuXHBhcg0KPj5ccGFyDQo+PlxwYXINCj4+IDUuMCBJUHY2
> IGNvbnNpZGVyYXRpb25zXHBhcg0KPj5ccGFyDQo+PiAgICAgICBUaGlzIGV4dGVuc2lvbiBj
> YW4gYmUgdXNlZCBpbiBJUHY0IGFuZCBJUHY2IGFsaWtlLlxwYXINCj4+XHBhcg0KPj4gUmVm
> ZXJlbmNlc1xwYXINCj5ccGFyDQo+ICAgIFsxXSBDLiBQZXJraW5zLCBFZGl0b3IuICBJUCBN
> b2JpbGl0eSBTdXBwb3J0LiAgUkZDIDIwMDIsIE9jdG9iZXJccGFyDQo+ICAgICAgICAxOTk2
> LlxwYXINCj4gICAgWzJdIFJleW5vbGRzLCBKLiwgYW5kIEouIFBvc3RlbCwgIkFzc2lnbmVk
> IE51bWJlcnMiLCBTVEQgMiwgUkZDXHBhcg0KPiAgICAgICAgMTcwMCwgVVNDL0luZm9ybWF0
> aW9uIFNjaWVuY2VzIEluc3RpdHV0ZSwgT2N0b2JlciAxOTk0LlxwYXINCj5ccGFyDQo+IEF1
> dGhvcnMnIEFkZHJlc3Nlc1xwYXINCj5ccGFyDQp9
>
> --openmail-part-01027968-00000002--
>
> --openmail-part-01027968-00000001
> Content-Type: application/ms-tnef; name="WINMAIL.DAT"
> Content-Disposition: attachment; filename="WINMAIL.DAT"
> Content-Transfer-Encoding: base64
>
> eJ8+IrRjAQaQCAAEAAAAAAABAAEAAQeQBgAIAAAA5AQAAAAAAADoAAEIgAcAGAAAAElQTS5N
> aWNyb3NvZnQgTWFpbC5Ob3RlADEIAQ2ABAACAAAAAgACAAEDkAYADAAAAAEAAAADABcAAQAA
> ABwAAQOQBgAMAAAAAQAAAAMANgAAAAAAOgABBIABAEIAAABSZTogW01PQklMRS1JUF0gRHJh
> ZnQgZm9yIFZlbmRvci9Pcmdhbml6YXRpb24gU3BlY2lmaWMgRXh0ZW5zaW9ucwAHFwEDkAYA
> EAAAAAEAAABAADkAUCXq5rsKvwFEBAEDkAYADAAAAAEAAAADAN4/r28AAD8CAQOQBgAUAAAA
> AQAAAB4AQhABAAAAAQAAAAAAAABzAAEDkAYAJAAAAAEAAAACATEAAQAAABEAAABIMDAwMDE3
> MzAwNjQyM2UxAAAAAK8DAQOQBgAMAAAAAQAAAAsAAgABAAAADwABA5AGAAwAAAABAAAACwAr
> AAAAAAA3AAEDkAYADAAAAAEAAAADAC4AAAAAADIAAQOQBgAoAAAAAQAAAAIBcQABAAAAFgAA
> AAG/Crvmq/bD+CJ2qxHTpHAAEFqqBcsAAHILAQOQBgBQAAAAAQAAAB4AcAABAAAAPgAAAFtN
> T0JJTEUtSVBdIERyYWZ0IGZvciBWZW5kb3IvT3JnYW5pemF0aW9uIFNwZWNpZmljIEV4dGVu
> c2lvbnMAAADEFgEDkAYAGAAAAAEAAAAeAD0AAQAAAAUAAABSRTogAAAAAFMBAQOQBgAkAAAA
> AQAAAAsAAIALIAYAAAAAAMAAAAAAAABGAAAAAAWIAAAAAAAAUAIBA5AGACQAAAABAAAACwAB
> gAsgBgAAAAAAwAAAAAAAAEYAAAAAAIgAAAAAAABMAgEDkAYALAAAAAEAAAAeAAKACCAGAAAA
> AADAAAAAAAAARgAAAAA4hQAAAQAAAAEAAAAAAAAAlAIBA5AGACwAAAABAAAAHgADgAggBgAA
> AAAAwAAAAAAAAEYAAAAAN4UAAAEAAAABAAAAAAAAAJQCAQOQBgAsAAAAAQAAAB4ABIAIIAYA
> AAAAAMAAAAAAAABGAAAAADaFAAABAAAAAQAAAAAAAACUAgEDkAYAJAAAAAEAAAADAAWACCAG
> AAAAAADAAAAAAAAARgAAAAAYhQAAAAAAAFoCAQOQBgAkAAAAAQAAAAMABoAIIAYAAAAAAMAA
> AAAAAABGAAAAABGFAAAAAAAAVAIBA5AGACQAAAABAAAAAwAHgAggBgAAAAAAwAAAAAAAAEYA
> AAAAEIUAAAAAAABUAgEDkAYAJAAAAAEAAAALAAiACCAGAAAAAADAAAAAAAAARgAAAAAOhQAA
> AAAAAFsCAQOQBgAkAAAAAQAAAAMACYAIIAYAAAAAAMAAAAAAAABGAAAAAAGFAAAAAAAARwIB
> A5AGACQAAAABAAAACwAKgAggBgAAAAAAwAAAAAAAAEYAAAAABoUAAAAAAABVAgEDkAYALAAA
> AAEAAAAeAAuACCAGAAAAAADAAAAAAAAARgAAAABUhQAAAQAAAAQAAAA4LjUAVwMBA5AGACQA
> AAABAAAAAwAMgAggBgAAAAAAwAAAAAAAAEYAAAAAUoUAADwYAADvAgEDkAYAIAAAAAEAAAAC
> AQswAQAAABAAAAAg+MP2q3bTEaRwABBaqgXLHggBA5AGAAwAAAABAAAAAwCAEP////+QBAEJ
> AAQAAgAAAAAAAAABA5AGAAwAAAABAAAACwAjAAAAAAAvAAEDkAYADAAAAAEAAAALACkAAAAA
> ADUAAQSQBgAcAgAAAQAAABIAAAAeAAEwAQAAAAwAAAAnTU9CSUxFLUlQJwACAf8PAQAAAE4A
> AAAAAAAAgSsfpL6jEBmdbgDdAQ9UAgAAAABNT0JJTEUtSVAAU01UUABNT0JJTEUtSVBAU1RB
> TkRBUkRTLk5PUlRFTE5FVFdPUktTLkNPTQAAAAMAFQwBAAAAAwAAMAAAAAAeAAIwAQAAAAUA
> AABTTVRQAAAAAB4AGgwBAAAADgAAAFdlaWp1biBKaWFuZwAAAAACARkMAQAAADoAAAAAAAAA
> jVVM0Ow8Ec6B/wgACbEDegEAAAALAAAAAAAAADEdSmlhbmceMh1XZWlqdW4eNR1ubXBzZDIA
> AAAeAAMwAQAAACcAAABNT0JJTEUtSVBAU1RBTkRBUkRTLk5PUlRFTE5FVFdPUktTLkNPTQAA
> AwD/XwAAAAADAP1fAQAAAB4A9l8BAAAACgAAAE1PQklMRS1JUAAAAAIB918BAAAATgAAAAAA
> AACBKx+kvqMQGZ1uAN0BD1QCAAAAAE1PQklMRS1JUABTTVRQAE1PQklMRS1JUEBTVEFOREFS
> RFMuTk9SVEVMTkVUV09SS1MuQ09NAAAACwAPDgAABIACAQswAQAAACwAAABTTVRQOk1PQklM
> RS1JUEBTVEFOREFSRFMuTk9SVEVMTkVUV09SS1MuQ09NAAMA/g8GAAAAAwAAOQAAAAALAEA6
> AQAGAAMAcToAAAAAMWY=
>
> --openmail-part-01027968-00000001--
>

---

From: Gopal Dommety <[email-masked]>
Date: Tue, 5 Oct 1999 17:56:29 -0700

Hello Rajesh:

        I see your point about "Normal" type extension should be two
bytes length.  The reason it is one byte is because of compatibility
with existing implementations. (If the group feels that this is not a
concern, we can make it two byte length. Might not be a good
idea). More explainiation below:

    Ideally, it would have  been good to have both  as two byte length
(as you suggested). For
    the Normal type if a HA does not understand it, it will have to skip
    it according to RFC2002. In thi case the legth is assumed to be of
    one byte. So, having a two byte lenght could create interoperability
    problems. But for the Critical type, if the HA does not understand it
    if discards it. If it does undertand it, HA will know how to
process it.

Thanks
Gopal

---

From: Jouni Malinen <[email-masked]>
Date: Wed, 6 Oct 1999 12:53:02 +0300

> idea). More explainiation below:

That would certainly break the compatibility and I would not like to
see that kind of a change taking place without very good reasons. This
problem with long extensions can be handled in a compatible way. I
proposed quite similar vendor extension handling on this list in May.

(http://standards.nortelnetworks.com/scripts/wa.exe?A2=ind9905&L=mobile-ip&F=&S=&P=18505)

One of the differences was that both the vendor extensions used one
byte length field as is actually specified in the RFC 2002 (Chap. 1.9)
for all the extensions. If the data part of the extensions is longer
than about 250 bytes (255 - extra fields in the vendor ext. header)
the extension is divided into two or more extensions using same type
fields. This way the receiver can concatenate the data before further
processing. This is a bit more complicated, but it does not break the
compatibility, which I think should be an important factor in the
development of new Mobile IP additions.

>     if discards it. If it does undertand it, HA will know how to

This is probably the case with many of the implementations, but I have
seen at least one implementation crashing on segmentation fault when I
tried to use two bytes long length field for an extension ;). This can
certainly be seen as an implementation bug, but anyway I think that
the RFC 2002 specifies the one byte long length field for all the
extensions and if this is going to be changed, it would also need to
be specified in the (hopefully) upcoming RFC that obsoletes RFC 2002.

--
Jouni Malinen

---

From: Gopal Dommety <[email-masked]>
Date: Wed, 6 Oct 1999 10:28:48 -0700

Hello Jouni:

I agree with you. That is the reason why the draft proposes two
extensions instead of one. If an implementation does not understand
these extensions, then in the case of Normal type it will skip it and
critical type it will drop the packet. The TLV processing if you want
to implement the critical type gets interesting :)

I have also a statement in the restrictions section regarding the
ordering of attributes to leave scope for attribute chaining.

So, will leave the draft as it is.

> be specified in the (hopefully) upcoming RFC that obsoletes RFC 2002.

RFC spelling it out would be really useful.

Thanks
-Gopal